// Get the value of the use_javascript from drupalSettings
var use_javascript = drupalSettings.openai_search.use_javascript;
console.log("node type is " + drupalSettings.openai_search.node_type);
var node_type = drupalSettings.openai_search.node_type;
var ai_url = drupalSettings.openai_search.ai_url;

function waitForElm(selector) {
  return new Promise(resolve => {
    if (document.querySelector(selector)) {
      return resolve(document.querySelector(selector));
    }

    const observer = new MutationObserver(mutations => {
      if (document.querySelector(selector)) {
        resolve(document.querySelector(selector));
        observer.disconnect();
      }
    });

    observer.observe(document.body, {
      childList: true,
      subtree: true
    });
  });
}

waitForElm('#js-submit').then((elm) => {
  document.getElementById('js-submit').addEventListener('click', function(e) {
    // Prevent the default form submission
    if (use_javascript === 1) {
      e.preventDefault();
    }
    else {
      return;
    }
    // change the id of spinner to be visible
    document.getElementById('spinner').style.display = 'block';
    // Get the search query
    var searchQuery = document.getElementById('user-search-id').value;
    // Send a request to the server with the search query url friendly as an argument to http://main-bvxea6i-is5ueuku5nw4g.us.platformsh.site/json
    // make searchQuery url friendly
    // make searchQuery url friendly
    searchQuery = searchQuery.replace(/ /g, '+');
    // searchQuery = searchQuery.replace(' ', '%20');
    if (node_type == "private_gpts") {
      var url = drupalSettings.openai_search.restful_url + "/" + ai_url + "/" + searchQuery + '?UNIQUE_SESSION_COOKIE_NAME=' + drupalSettings.openai_search.session_id;
    }
    else {
      var url = drupalSettings.openai_search.restful_url + "/" + searchQuery + '?UNIQUE_SESSION_COOKIE_NAME=' + drupalSettings.openai_search.session_id;
    }
    console.log("url is " + url);
    // Get the response from the server
    fetch(url, {
      method: 'GET',
      headers: {
        'Accept': 'application/json',
      },
    })
      .then(response => response.json())
      .then(response=> {
        if (response) {
          document.getElementById('spinner').style.display = 'none';
          // Display the response
          data = response.documents;
          // turn the data into a string
          data = JSON.stringify(data);
          // replace any brackets with a <br/> tag
          data = data.replace(/[\[\]"]+/g, '');
          // format any urls in the data to be clickable and open in a new window
          var regex = /(https?:\/\/[^\s]+)/g;
          // make sure any urls are clickable
          data = data.replace(regex, "<a href='$1' target='_blank'>$1</a>");
          // append the data to the id of search-history-id in the textarea.
          var textarea = document.getElementById('search-history-id');
          // get the text the user entered in the textfield with id user-search-id and append it to the textarea
          var user_search = document.getElementById('user-search-id').value;
          textarea.innerHTML += '<b><i>' + user_search + '</i></b><br>';
          textarea.innerHTML += data + '<br>';
          // clear the user search textfield
          document.getElementById('user-search-id').value = '';
          // scroll to the bottom of the textarea
          //textarea.scrollTop = textarea.scrollHeight;
        }
      });

  });
});
